local f = CreateFrame("Frame");
local g = CreateFrame("Frame");
ThanksMSG = "Thank yo~u for the Resurrection."; -- ThanksMSG
UnGhostMSG = "Walked back to my body."; -- UnGhostMSG
DeadMSG = "I died, please resurrect me at earliest convenience."; -- DeadMSG
SLASH_AR1 = "/ar";
ARSwitch = true;
language = GetDefaultLanguage(unit);
CR = false;
CombatStatus = false; -- Combat Status
messages = true;

f:RegisterEvent("PLAYER_DEAD"); -- Event that fires when player Dies
f:RegisterEvent("RESURRECT_REQUEST"); -- Event that Fires on Resurrect Request
f:RegisterEvent("PLAYER_UNGHOST"); --Fires when resurrected from GHOST from CORPSE
f:RegisterEvent("PLAYER_SUMMON"); -- Fires when being Summoned
g:RegisterEvent("PLAYER_REGEN_DISABLED"); -- Fires when Entering Combat
g:RegisterEvent("PLAYER_REGEN_ENABLED"); -- Fires when Leaving Combat

function commandHandler(msg)
  if msg == "on" then
    ARSwitch = true;
    print("Auto Resurrections have been enabled. Use the /ar off command to disable Auto Resurrections.");
  end
  if msg == "off" then
    ARSwitch = false;
    print("Auto Resurrections have been disabled. Use the /ar on command to enable Auto Ressurrections.");
  end
  if msg == "cr_on" then
    CR = true;
    print("Combat Resurrections have been enabled. Use the /ar cr_off command to disable Combat Resurrections.");
  end
  if msg == "cr_off" then
    CR = false;
    print("Combat Resurrections have been disabled. Use the /ar cr_on command to enable Combat Resurrections.");
  end
  if msg == "m_on" then
    messages = true;
    print("Turned on Messages. Use /ar m_off to disable them.");
  end
  if msg == "m_off" then
    messages = false;
    print("Turned off Messages. Use /ar m_on to enable them.");
  end
end

SlashCmdList["AR"] = commandHandler;

g:SetScript("OnEvent", function(self, event, ...)
	if event == "PLAYER_REGEN_ENABLED" then -- Tells the system that Player is out of combat and Assigns false to CombatStatus
		CombatStatus = false; -- Assigns false to CombatStatus
	end
	if event == "PLAYER_REGEN_DISABLED" then -- Tells the system that Player is in Combat and Assigns true to CombatStatus
		CombatStatus = true; -- Assigns True to CombatStatus
	end
end)

if ARSwitch == true then
  f:SetScript("OnEvent", function(self, event, ...)
    if CR == true then
      if event == "PLAYER_DEAD" then -- Fires when Player dies
        if messages == true then
          SendChatMessage(DeadMSG, "PARTY", language);
          SendChatMessage(DeadMSG, "RAID", language);
          SendChatMessage(DeadMSG, "INSTANCE_CHAT", language);
        end
      end
      if event == "RESURRECT_REQUEST" then -- Fires on Ruserrect Request Event
        AcceptResurrect(UnitName("player")); -- Accepts Resurrection Request
        if messages == true then  
          SendChatMessage(ThanksMSG, "PARTY", language); -- Sends Thanks Chat MSG in PARTY
          SendChatMessage(ThanksMSG, "RAID", language); -- Sends Thanks Chat MSG in RAID
          SendChatMessage(ThanksMSG, "INTANCE_CHAT", language);
        end
       end
      if event == "PLAYER_UNGHOST" then -- Fires when Player Walks to body and Resurrects
        if messages == true then
          SendChatMessage(UnGhostMSG, "PARTY", language); -- Sends UnGhost Chat MSG in PARTY
          SendChatMessage(UnGhostMSG, "RAID", language); -- Sends UnGhost Chat MSG in RAID
          SendChatMessage(UnGhostMSG, "INSTANCE_CHAT", language);
        end
      end
    end
      
    if CR == false then
      if CombatStatus == true then
        if event == "PLAYER_DEAD" then
          if messages == true then
            SendChatMessage(DeadMSG, "PARTY", language); -- Sends DeadMSG Chat MSG in PARTY
            SendChatMessage(DeadMSG, "RAID", language); -- Sends DeadMSG chat MSG in RAID
            SendChatMessage(DeadMSG, "INSTANCE_CHAT", language);
          end
        end
     end 
      if CombatStatus == false then
        if event == "PLAYER_DEAD" then
          if messages == true then
            SendChatMessage(DeadMSG, "PARTY", language); -- Sends DeadMSG chat MSG in PARTY
            SendChatMessage(DeadMSG, "RAID", language); -- Sends DeadMSG chat MSG in RAID
            SendChatMessage(DeadMSG, "INSTANCE_CHAT", language);
          end
        end
        if event == "RESURRECT_REQUEST" then
          AcceptResurrect(UnitName("player")); -- Accepts Resurrection
          if messages == true then
            SendChatMessage(ThanksMSG, "PARTY", language); -- Sends ThanksMSG chat MSG in PARTY
            SendChatMessage(ThanksMSG, "RAID", language); -- Sends ThanksMSG chat MSG in RAID
            SendChatMessage(ThanksMSG, "INSTANCE_CHAT", language);
          end
        end
        if event == "PLAYER_UNGHOST" then
          if messages == true then
            SendChatMessage(UnGhostMSG, "PARTY", language); -- Sends UnGhostMSG chat MSG in PARTY
            SendChatMessage(UnGhostMSG, "RAID", language); -- Sends UnGhostMSG chat MSG in RAID
            SendChatMessage(UnGhostMSG, "INSTANCE_CHAT", language);
          end
       end
      end
    end
  end)
end

if ARSwitch == false then
  f:SetScript("OnEvent", function(self, event, ...)
    if event == "PLAYER_DEAD" then
      print("Auto Resurrections have been turned off. Please use ./ar on to re-enable them.")
    end
  end)
end